#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "dSFMT.h"

/**********
GIMT
argv[1]: list
argv[2]: root node
argv[3]: step number
argv[4]: trial
*/

//weight
#define a 0.2 

int main(int argc, char *argv[])
{
	int Step = atoi(argv[3]);
	int Seed = atoi(argv[4]);
	
	dsfmt_t dsfmt1;
	dsfmt_init_gen_rand(&dsfmt1,Seed);
	
	int i,j,x,y;
	double z;
	
	//list
	FILE *fp;
	
	int *ll,*lr,*filter,*linenum,*deg;
	
	int max=0,Line=1;
	
	ll=(int *)calloc(1,sizeof(int));
	lr=(int *)calloc(1,sizeof(int));
	
	fp=fopen(argv[1],"r");
	while(fscanf(fp,"%d %d",&x,&y)!=EOF)
	{
	max=maximum(max,x);
	max=maximum(max,y);
	ll=(int *)realloc(ll,(Line+1)*sizeof(int));
	lr=(int *)realloc(lr,(Line+1)*sizeof(int));
	ll[Line]=x;
	lr[Line]=y;
	Line++;
	}
	fclose(fp);
	//list
	
	max++;
	filter=(int *)calloc(max,sizeof(int));
	deg=(int *)calloc(max,sizeof(int));
	for(i=1;i<Line;i++)
	{
		filter[ll[i]]=1;
		filter[lr[i]]=1;
		deg[ll[i]]+=1;
	}
	
	//line which node i starts
	linenum=(int *)calloc(max+1,sizeof(int));
	for(i=1;i<Line;i++)
	{
		if(ll[i] != ll[i-1])
		{
			linenum[ll[i]]=i;
			if(ll[i] - ll[i-1] >1)
			{
				for(j=ll[i-1]+1;j<ll[i];j++)
				{
					linenum[j]=linenum[ll[i]];
				}
			}
		}
	}
	linenum[max]=Line;
		
	int *walker;
	walker=(int *)calloc(Step+1,sizeof(int));
	
	double prob,rand,sum;
	walker[0]=atoi(argv[2]);
	
	//if there is a root node
	if(filter[walker[0]]==1)
	{
	
	for(i=0;i<Step;i++)
	{
	sum=0;
	prob=0;
	rand=dsfmt_genrand_close_open(&dsfmt1);
	
	for(j=linenum[walker[i]];j<linenum[walker[i]+1];j++)
	{
		sum+=pow(deg[lr[j]],a);
	}
	
	for(j=linenum[walker[i]];j<linenum[walker[i]+1];j++)
	{
		prob+=pow(deg[lr[j]],a)/sum;
		
	if(prob>rand)
	{
		walker[i+1]=lr[j];
		break;
	}
	}
	}
	
	//output 
	for(i=0;i<Step;i++)
	{
		printf("%d %d\n",i,walker[i]);
	}
	
	}//root node : finish
	
	free(ll);
	free(lr);
	free(filter);
	free(linenum);
	free(walker);
	free(deg);
}

int maximum(int aa,int bb)
{
	if(aa>bb)
	{
		return(aa);
	}else{
		return(bb);
	}
}
